<?php

require_once('api/Simpla.php');

/*
 * 
 * Преобразует число к требуемому платежкой формату.
 * 
 */

function to_float($sum) {
    $sum2 = round(floatval($sum), 2);
    $sum = sprintf("%01.2f", $sum2);
    if (substr($sum, -1) == "0") {
        $sum = sprintf("%01.1f", $sum2);
    }
    return $sum;
}

class OnPay extends Simpla {
    /*
     * 
     * Формирует форму для фронтэнда, добавляя туда необходимые $_POST
     * 
     */

    public function checkout_form($order_id, $button_text = null) {
        if (empty($button_text))
            $button_text = 'Перейти к оплате';

        $order = $this->orders->get_order(intval($order_id));
        $payment_method = $this->payment->get_payment_method($order->payment_method_id);
        $payment_settings = $this->payment->get_payment_settings($payment_method->id);
        $price = to_float($this->money->convert($order->total_price, $payment_method->currency_id, false));
        $currency = $this->money->get_currency($payment_method->currency_id);
        $convert = "yes";
        $pay_mode = 'fix';
        $success_url = $this->config->root_url . '/order/' . $order->url;
        $fail_url = $this->config->root_url . '/order/' . $order->url;

        // регистрационная информация
        $login = $payment_settings['login'];
        $secret_key = $payment_settings['secret_key'];

        // номер заказа
        $pay_for = $order->id;

        // формирование подписи pay_mode;price;ticker;pay_for;convert;secret_key
        $signature = md5("$pay_mode;$price;{$currency->code};$pay_for;$convert;$secret_key");
        
        /*
         * pay_mode - фиксировать ли сумму платежа (должно быть fix, иначе можно ввести любую сумму на стороне платежки)
         * price - сколько платить
         * currency - код валюты платежа
         * pay_for - идентификатор платежа на стороне сайта, в нашем случае ID заказа
         * convert - переводить ли поступающий платеж в указанную валюту (yes или no)
         * signature - подпись магазина
         * url_success, url_fail - адреса возврата
         * 
         */
        $button = "<form action='https://secure.onpay.ru/pay/$login' method=POST>" .
                "<input type=hidden name=pay_mode value='$pay_mode'>" .
                "<input type=hidden name=price value='$price'>" .
                "<input type=hidden name=currency value='{$currency->code}'>" .
                "<input type=hidden name=pay_for value='$pay_for'>" .
                "<input type=hidden name=convert value='$convert'>" .
                "<input type=hidden name=md5 value='$signature'>" .
                "<input type=hidden name=url_success value='$success_url'>" .
                "<input type=hidden name=url_fail value='$fail_url'>" .
                "<input type=submit class=checkout_button value='Перейти к оплате &#8594;'>" .
                "</form>";
        return $button;
    }

}